// Animate.cpp: implementation of the Animate class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "Color.h"
#include "Animate.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

#define Rsize (TopSize+15)
#define Fsize 5

void Sound(int);


Animate::Animate()
{
}

Animate::~Animate()
{
}

void Animate::Add(CPoint point)
{
	circle st; st.xy=point; st.r=-Rsize;
	list.Add(st);
}


void Animate::Del(CPoint point)
{
	circle st; st.xy=point; st.r=TopSize-3;
	list.Add(st);
}

void Animate::Step(CDC *dc)
{
	int n=list.GetSize(); CPoint point; bool del;
	if(!n) return;
	while(n--)
	{
		int r=list[n].r;
		point=list[n].xy; del=false;
		if(r>0)
		{
			r++; del=(r>Rsize);
			if (r<Rsize-Fsize+1) Circle(dc,point,r+Fsize,1);
			Circle(dc,point,r,0);
		}
		else
		{
			if(-r>TopSize) Circle(dc,point,-r,1);
			Circle(dc,point,-r+Fsize,0);
			r++; del=(-r+Fsize<TopSize);
		}
		if(del) list.RemoveAt(n); else list[n].r=r;
	}
}

void Animate::Circle(CDC *dc,CPoint &point, int r, bool color)
{
	DWORD ink;
	if(color) ink=ColorInterpolation(COLOR_WINDOWTEXT,COLOR_WINDOW,TopSize,Rsize,r);
		else ink=GetSysColor(COLOR_WINDOW);
	CPen pen(0,1,ink), *oldpen;
	oldpen=dc->SelectObject(&pen);
	dc->Arc(point.x-r,point.y-r,point.x+r,point.y+r,0,0,0,0);
	dc->SelectObject(oldpen);
}

bool Animate::isActive()
{
	return list.GetSize()!=0;
}
