// ColorDoc.cpp : implementation of the CColorDoc class
//

#include "stdafx.h"
#include "Color.h"

#include "ColorDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define FLAGS_GRID 1
#define FLAGS_GRID_DOTS 4
#define FLAGS_BLACK 2
#define FLAGS_LINK_DOTS 8
#define FLAGS_MATRIX 16

/////////////////////////////////////////////////////////////////////////////
// CColorDoc

IMPLEMENT_DYNCREATE(CColorDoc, CDocument)

BEGIN_MESSAGE_MAP(CColorDoc, CDocument)
	//{{AFX_MSG_MAP(CColorDoc)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorDoc construction/destruction

CColorDoc::CColorDoc()
{
	Flags=FLAGS_GRID_DOTS; 
	oldpull.x=oldpull.y=0;MatrixOffset.x=MatrixOffset.y=10;
	Cell.min=30, Cell.max=100, Cell.mode=0; Cell.fix=true; Cell.color1=RGB(0,-1,0); Cell.color2=RGB(0,0,-1); Cell.color3=RGB(88,88,88);
}

CColorDoc::~CColorDoc()
{
}

BOOL CColorDoc::OnNewDocument()
{
	if (!CDocument::OnNewDocument()) return FALSE;
	Add(CPoint(30,30));
	Add(CPoint(100,50));
	Add(CPoint(50,110));
	CurrentTop=0; SecondTop=1;AddLink();
	CurrentTop=2; SecondTop=1;AddLink();
	CurrentTop=2; SecondTop=0; AddLink();
	opengl.BollSize=TopSize;
	opengl.LinkSize=3;
	opengl.BollColor=RGB(99,99,99);
	opengl.LinkColor=RGB(-1,0,0);
	opengl.FixColor=false;
	opengl.SelectType=Torus;
	return TRUE;
}



/////////////////////////////////////////////////////////////////////////////
// CColorDoc serialization

void CColorDoc::Serialize(CArchive& ar)
{
	if (ar.IsStoring())
	{
	}
	else
	{
	}
}

/////////////////////////////////////////////////////////////////////////////
// CColorDoc diagnostics

#ifdef _DEBUG
void CColorDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CColorDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CColorDoc commands

void CColorDoc::ShowTop(int index, CDC *dc)
{
	CPoint point=GetTOP(index); int id;
	if(index==CurrentTop) id=IDI_ICON3;
	else if (index==SecondTop) id=IDI_ICON2; else id=IDI_ICON1;
	DrawIconEx(dc->m_hDC,point.x-TopSize,point.y-TopSize,AfxGetApp()->LoadIcon(id),TopSize*2,TopSize*2,0,0,DI_NORMAL);
	/*
	DWORD c2,c3;
	if (index==CurrentTop) c2=RGB(0,-1,-1),c3=RGB(-50,-1,-1);
	else if (index==SecondTop) c2=RGB(-1,-1,0),c3=RGB(-50,-1,-1);
	else c2=RGB(-30,-30,-30), c3=RGB(-20,-20,-20);

	CPoint point=GetTOP(index);
	CPen pen1(0,2,RGB(0,0,0));
	CBrush pen2(c2);
	CPen pen3(0,3,c3);
	CPen pen4(0,6,RGB(-1,-1,-1));
	CPen pen5(0,2,RGB(0,-31,-31));
	CPen *oldpen=dc->SelectObject(&pen1);
	CBrush *oldbrush=dc->SelectObject(&pen2);
	dc->Ellipse(point.x-TopSize,point.y-TopSize,point.x+TopSize,point.y+TopSize);
	dc->SelectObject(&pen3);
	dc->Arc(point.x-TopSize+5,point.y-TopSize+5,point.x+TopSize-5,point.y+TopSize-5,point.x,point.y-TopSize,point.x-TopSize,point.y);
	if (index==CurrentTop) {
		dc->SelectObject(&pen4);
		dc->MoveTo(point);
		dc->LineTo(point);
		dc->SelectObject(&pen5);
		dc->Arc(point.x-TopSize+3,point.y-TopSize+3,point.x+TopSize-3,point.y+TopSize-3,point.x,point.y+TopSize,point.x+TopSize,point.y);
	}
	dc->SelectObject(oldpen);
	dc->SelectObject(oldbrush);
	*/
}

SIZE CColorDoc::Show(CDC *dc)
{
	SIZE size; int x,y,n; CPen *oldpen;
	CRect rect=GetSize(); size.cx=rect.right+30; size.cy=rect.bottom+30; dc->GetClipBox(rect);
	if (size.cx>rect.right) rect.right=size.cx;
	if (size.cy>rect.bottom) rect.bottom=size.cy;
	if (Grid()) {
		if (Flags & FLAGS_GRID_DOTS) for(x=0;x<rect.right;x+=TopSize*2) for(y=0;y<rect.bottom;y+=TopSize*2) dc->SetPixel(x,y,RGB(0,0,0));
		else {
			CPen pen(0,1,RGB(100,-1,100));
			oldpen=dc->SelectObject(&pen);
			for(x=0; x<rect.right; x+=TopSize*2) dc->MoveTo(x,0), dc->LineTo(x,rect.bottom);
			for(y=0; y<rect.bottom; y+=TopSize*2) dc->MoveTo(0,y), dc->LineTo(rect.right,y);
			dc->SelectObject(oldpen);
		}
	}
	for(n=0; n<GetLINKs(); n++) {
		CPen pen(0,1,GetColor(n));
		oldpen=dc->SelectObject(&pen);
		CPoint point=GetLINK(n);
		DrawLine(dc,GetTOP(point.x),GetTOP(point.y),GetCurve(n));
		dc->SelectObject(oldpen);
	}
	for(n=0; n<GetTOPs(); n++) ShowTop(n,dc);
	if(Flags&FLAGS_MATRIX) {
		int s=MatrixSize(); bool act1,act2=false;
		int q=GetTOPs(); CPen pen(0,1,Cell.color3); oldpen=dc->SelectObject(&pen);
		CPen penx(0,1,Cell.color2);
		for(y=0; y<q; y++) for(x=0; x<q; x++)
		{
			act1=(Cell.x==x && Cell.y==y);
			CPoint point1=MatrixOffset+CPoint(x*s+1,y*s+1);
			CPoint point2=point1+CPoint(s-2,s-2);
			dc->MoveTo(point1);
			if(act1) dc->SelectObject(penx);
			dc->LineTo(point2.x,point1.y); dc->LineTo(point2);
			dc->LineTo(point1.x,point2.y); dc->LineTo(point1);
			if(act1) dc->SelectObject(pen),act2=true;
		}
		if(act2) dc->SelectObject(penx);
		dc->MoveTo(MatrixOffset.x+5,MatrixOffset.y-2); dc->LineTo(MatrixOffset.x+q*s-5,MatrixOffset.y-2);
		dc->MoveTo(MatrixOffset.x-2,MatrixOffset.y+5); dc->LineTo(MatrixOffset.x-2,MatrixOffset.y+q*s-5);
		dc->MoveTo(MatrixOffset.x+q*s+2,MatrixOffset.y+5); dc->LineTo(MatrixOffset.x+q*s+2,MatrixOffset.y+q*s-5);
		dc->MoveTo(MatrixOffset.x+5,MatrixOffset.y+q*s+2); dc->LineTo(MatrixOffset.x+q*s-5,MatrixOffset.y+q*s+2);
		dc->SelectObject(oldpen);
		for(n=0; n<GetLINKs(); n++) { int t;
			CPoint point=GetLINK(n); point.x*=s; point.y*=s;
			for(char p=0;p<2;p++) {
			for(y=2; y<s-1; y++) for(x=2+(y&1); x<s-1; x+=2)
			{
				DWORD color=Cell.color1;
				if(!Cell.fix) color=GetColor(n);
				dc->SetPixel(point.x+x+MatrixOffset.x,point.y+y+MatrixOffset.y,color);
			}
				t=point.x,point.x=point.y,point.y=t;
			}
		}
	}
	return size;
}


bool CColorDoc::SelectTop(CPoint point)
{
	int old=CurrentTop;
	CurrentTop=FindCurrent(point);
	return old!=CurrentTop;
}

bool CColorDoc::Grid(bool togle)
{
	if (togle) Flags ^=FLAGS_GRID;
	return Flags & FLAGS_GRID;
}

//    Current   

void CColorDoc::PullLine(CPoint point,CDC *dc)
{
	CPen pen1(0,1,GetSysColor(COLOR_WINDOW));
	CPen pen2(0,1,GetSysColor(COLOR_WINDOWTEXT));
	CPen *oldpen=dc->SelectObject(&pen1);
	dc->MoveTo(oldpull);
	dc->LineTo(GetTOP(CurrentTop));
	dc->SelectObject(&pen2);
	dc->LineTo(point);
	dc->SelectObject(oldpen);
	oldpull=point;
	SecondTop=FindCurrent(point);
}

//    Current  Second 

bool CColorDoc::AddLink()
{
	bool res=false;
	if(SecondTop>=0 && CurrentTop>=0) res=Graph::AddLink(CurrentTop,SecondTop);		
	CurrentTop=SecondTop=-1;
	return res;
}

//    

void CColorDoc::DrawLine(CDC *dc, CPoint point1, CPoint point2, int r)
{
	CPoint point; CPoint temp; int l=Distance(point1,point2);
	if (r) {
		r=r*(l/2+5)/65536;
		point=GetCircleCenter(point1, point2, r);
		if(r>0) temp=point1, point1=point2, point2=temp;
		dc->Arc(point.x-r,point.y-r,point.x+r,point.y+r,point1.x,point1.y,point2.x,point2.y);
	} else {
		point=point1-point2; point.x=point.x*TopSize/l; point.y=point.y*TopSize/l;
		point1-=point;
		point2+=point;
		dc->MoveTo(point1);
		dc->LineTo(point2);
	}
}


bool CColorDoc::Black(bool togle)
{
	if(togle) Flags^=FLAGS_BLACK;
	return Flags & FLAGS_BLACK != 0;
}

bool CColorDoc::SelectLink(CPoint point)
{
	return Graph::SelectLink(point) && !(Flags & FLAGS_BLACK);
}

bool CColorDoc::GridDots(bool togle, bool set)
{
	if (togle) { Flags |= FLAGS_GRID | FLAGS_GRID_DOTS; if(!set) Flags&= ~FLAGS_GRID_DOTS; }
	return Flags & FLAGS_GRID_DOTS != 0;
}

//  (  )

bool CColorDoc::Remove()
{
	if (CurrentTop>=0) { Del(CurrentTop); return true; }
	bool res=false; int n=GetLINKs();
	while(n--) {
		if(isSelect(n)) DelLink(n), res=true;
	}
	return res;
}

void CColorDoc::PullCircle(double R, CDC *dc)
{
	CPoint pointc=GetCenter();
	int r=(int)(R*Scaly(0));
	CPen pen(PS_DOT,1,GetSysColor(COLOR_APPWORKSPACE ));
	CPen *oldpen=dc->SelectObject(&pen);
	dc->Ellipse(pointc.x-r,pointc.y-r,pointc.x+r,pointc.y+r);
	dc->SelectObject(oldpen);
}

bool CColorDoc::Matrix(bool togle, CPoint *point)
{
	if(point) *point=MatrixOffset;
	if(togle) Flags^=FLAGS_MATRIX;
	return (Flags&FLAGS_MATRIX)!=0;
}

void CColorDoc::MatrixSet(CPoint point)
{
	if(point.x<0) point.x=0;
	if(point.y<0) point.y=0;
	MatrixOffset=point;
}

int CColorDoc::MatrixSize()
{
	int size=Cell.min;
	if(Cell.mode)
	{
		int s=Cell.max/GetTOPs();
		if(s>size) size=s;
	}
	return size;
}

#include "MatrixSize.h"

void CColorDoc::MatrixSetup()
{
	::MatrixSize dlg;
	dlg.m_size1=Cell.min;
	dlg.m_size2=Cell.max;
	dlg.m_mode=Cell.mode;
	dlg.color1=Cell.color1;
	dlg.color2=Cell.color2;
	dlg.color3=Cell.color3;
	dlg.m_fix=Cell.fix;
	if(dlg.DoModal()!=IDOK) return;
	Cell.color1=dlg.color1;
	Cell.color2=dlg.color2;
	Cell.color3=dlg.color3;
	Cell.fix=dlg.m_fix;
	Cell.min=dlg.m_size1;
	Cell.max=dlg.m_size2;
	Cell.mode=dlg.m_mode;
}

bool CColorDoc::MatrixDetect(CPoint point)
{
	if(!(Flags&FLAGS_MATRIX)) { Cell.x=-1; return false;}
	point-=MatrixOffset;
	int size=MatrixSize(); int q=GetTOPs();
	if(point.x<0 || point.y<0 || point.x>q*size || point.y>q*size) point.x=point.y=-1;
	else point.x/=size,point.y/=size;
	if(Cell.x!=point.x || Cell.y!=point.y) Cell.modify=true;
	Cell.x=point.x; Cell.y=point.y;
//	CurrentTop=point.x; SecondTop=point.y;	
	return point.x>=0;
}

bool CColorDoc::MatrixIsModify()
{
	bool res=Cell.modify; Cell.modify=false; return res;
}

void CColorDoc::MatrixClick()
{
	int n; if(Cell.x==Cell.y) return;
	if(Cell.x<Cell.y) n=Cell.x,Cell.x=Cell.y,Cell.y=n;
	for(n=0; n<GetLINKs(); n++) { CPoint point=GetLINK(n); if(Cell.x==point.x && Cell.y==point.y) break;}
	if(n==GetLINKs()) CurrentTop=Cell.x,SecondTop=Cell.y,AddLink(); else DelLink(n);
}


/*
save config
	fwrite(&Flags,1,sizeof(Flags),handler);
	fwrite(&MatrixOffset,1,sizeof(MatrixOffset),handler);
	fwrite(&opnegl,1,sizeof(opengl),handler);

save tex
\put(59.67,92.67){\circle*{4.85}}
\emline{83.00}{113.67}{1}{61.33}{77.33}{2}
	CPoint point,point1,point2;

\\begin{picture}(83.00,113.67)

	for(n=0; n<GetLINKs(); n++)
	{
		point =GetLINK(n);
		point1=GetTOP(point.x);
		point2=GetTOP(point.y);
		fprintf(handler,"\\emline{%d.00}{%d.00}{%d}{%d.00}{%d.00}{%d}\n",point1.x,point1.y,n+n, point2.x,point2.y,n+n+1);
	}

	for(n=0; n<GetTOPs(); n++)
	{
		point=GetTOPs(n);
		fprintf(handler,"\\put(%d.00,%d.00){\\circle*{4}}\n", point.x,point.y);
	}

\\end{picture}

*/

void CColorDoc::SaveConfig(FILE *)
{

}
