// ColorDoc.h : interface of the CColorDoc class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLORDOC_H__793D8ECC_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
#define AFX_COLORDOC_H__793D8ECC_230E_11D6_B8E1_F975CCF2E655__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Graph.h"
#include "opengl.h"

class CColorDoc : public CDocument, public Graph
{
protected: // create from serialization only
	CColorDoc();
	DECLARE_DYNCREATE(CColorDoc)
	int CurrentTop,SecondTop;
	CPoint oldpull;
	OpenGLconfig opengl;
// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColorDoc)
	public:
	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	//}}AFX_VIRTUAL

// Implementation
public:
	void SaveConfig(FILE *);
	void MatrixClick();
	bool MatrixIsModify();
	bool MatrixDetect(CPoint);
	int MatrixSize();
	void MatrixSetup();
	void MatrixSet(CPoint);
	bool Matrix(bool togle, CPoint *point=0);
	bool Remove();
	bool GridDots(bool togle=false, bool set=false);
	bool SelectLink(CPoint);
	bool Black(bool togle=false);
	void DrawLine(CDC*,CPoint,CPoint, int);
	bool AddLink();
	void PullLine(CPoint,CDC*);
	void PullCircle(double,CDC *);
	bool Grid(bool togle=false);
	bool SelectTop(CPoint);
	SIZE Show(CDC *dc);
	virtual ~CColorDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	char Flags;
	void ShowTop(int,CDC *);
	struct {int min;int max;int mode;int x;int y;bool modify; BOOL fix;DWORD color1; DWORD color2; DWORD color3;}Cell;

// Generated message map functions
protected:
	//{{AFX_MSG(CColorDoc)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	CPoint MatrixOffset;
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLORDOC_H__793D8ECC_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
