// ColorView.cpp : implementation of the CColorView class
//

#include "stdafx.h"
#include "Color.h"

#include "ColorDoc.h"
#include "ColorView.h"
#include "ReportDialog.h"
#include "ReportDialogTab.h"
#include "math.h"
#include "openGL.h"
#include "matrix.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define GRID_LINES 1
#define LINK_DOTS 2

/////////////////////////////////////////////////////////////////////////////
// CColorView

IMPLEMENT_DYNCREATE(CColorView, CScrollView)

BEGIN_MESSAGE_MAP(CColorView, CScrollView)
	//{{AFX_MSG_MAP(CColorView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_UPDATE_COMMAND_UI(IDS_MODE, OnUpdateMode)
	ON_UPDATE_COMMAND_UI(IDS_MOUSE, OnUpdateMousePos)
	ON_UPDATE_COMMAND_UI(IDS_TOPS, OnUpdateTopsQuantity)
	ON_UPDATE_COMMAND_UI(IDS_LINKS, OnUpdateLinksQuantity)
	ON_UPDATE_COMMAND_UI(ID_MODE_DEL, OnUpdateModeDel)
	ON_UPDATE_COMMAND_UI(ID_MODE_GRID, OnUpdateModeGrid)
	ON_UPDATE_COMMAND_UI(ID_MODE_LINK, OnUpdateModeLink)
	ON_UPDATE_COMMAND_UI(ID_MODE_NAME, OnUpdateModeName)
	ON_UPDATE_COMMAND_UI(ID_MODE_TOP, OnUpdateModeTop)
	ON_COMMAND(ID_MODE_DEL, OnModeDel)
	ON_COMMAND(ID_MODE_GRID, OnModeGrid)
	ON_COMMAND(ID_MODE_LINK, OnModeLink)
	ON_COMMAND(ID_MODE_NAME, OnModeName)
	ON_COMMAND(ID_MODE_TOP, OnModeTop)
	ON_WM_LBUTTONUP()
	ON_COMMAND(ID_MODE_BLACK, OnModeBlack)
	ON_UPDATE_COMMAND_UI(ID_MODE_BLACK, OnUpdateModeBlack)
	ON_COMMAND(ID_VIEW_GRID1, OnViewGrid1)
	ON_COMMAND(ID_VIEW_GRID2, OnViewGrid2)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GRID1, OnUpdateViewGrid1)
	ON_UPDATE_COMMAND_UI(ID_VIEW_GRID2, OnUpdateViewGrid2)
	ON_WM_ERASEBKGND()
	ON_WM_TIMER()
	ON_COMMAND(ID_REPORT, OnReport)
	ON_COMMAND(ID_OPENGL, OnOpengl)
	ON_COMMAND(ID_MOVE_DOWN, OnMoveDown)
	ON_COMMAND(ID_MODE_UP, OnModeUp)
	ON_COMMAND(ID_MOVE_LEFT, OnMoveLeft)
	ON_COMMAND(ID_MOVE_RIGHT, OnMoveRight)
	ON_COMMAND(ID_REDUCE, OnReduce)
	ON_COMMAND(ID_ROTATE1, OnRotate1)
	ON_COMMAND(ID_ROTATE2, OnRotate2)
	ON_COMMAND(ID_MAGNIFY, OnMagnify)
	ON_COMMAND(ID_MODE_MOVE, OnModeMove)
	ON_UPDATE_COMMAND_UI(ID_MODE_MOVE, OnUpdateModeMove)
	ON_COMMAND(ID_MODE_TURN, OnModeTurn)
	ON_UPDATE_COMMAND_UI(ID_MODE_TURN, OnUpdateModeTurn)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_MATRIX, OnMatrix)
	ON_UPDATE_COMMAND_UI(ID_MATRIX, OnUpdateMatrix)
	ON_COMMAND(ID_VIEW_MATRIX, OnViewMatrix)
	ON_COMMAND(ID_FILE_SAVE, OnFileSave)
	ON_WM_CANCELMODE()
	ON_COMMAND(ID_FILE_SAVE_AS, OnFileSaveAs)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CScrollView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CScrollView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorView construction/destruction

CColorView::CColorView()
{
/*	Pull=PullMatrix=OverMatrix=false; Flags=0; newScreen=true; EditMode=ADD; 
	Sound(IDW_STARTUP); 
	NumberMatrix test(10);
	int x,y,z;
	for(int n=0; n<50; n++)
	{
	TRACE("[matrix]\n");

	for( y=0; y<10; y++) 
	{
		for( x=0; x<10; x++) TRACE(" %d",(int)test.Get(x,y));
		TRACE("\n");
	}
	x=rand()%10; y=rand()%10; z=rand()%100;
	char buffer[20]; sprintf(buffer,"(%d,%d) %d",x,y,z);
	MessageBox(buffer,"SET",0);
	test.Set(x,y,z);
	}*/
}

CColorView::~CColorView()
{
}

BOOL CColorView::PreCreateWindow(CREATESTRUCT& cs)
{
	return CScrollView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CColorView drawing

void CColorView::OnDraw(CDC* pDC)
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

//	static bool xx=true;
//	if(xx) {
//		xx=false;
//		wnd.Create(AfxRegisterClass("ddd"),"title",WS_WISIBLE,CRect(10,10,200,200),0,0);
//	}

	fx.Step(pDC);
	if (newScreen) 
	{
		CDC mDC;
	    CBitmap bmp;
		CRect rect;
		CBrush brush(GetSysColor(COLOR_WINDOW));
		pDC->GetClipBox(rect);
		mDC.CreateCompatibleDC(pDC);
	    bmp.CreateCompatibleBitmap( pDC, rect.right,rect.bottom);
		mDC.SelectObject(bmp);
		mDC.OffsetViewportOrg(-rect.left,-rect.top);
		mDC.FillRect(&rect,&brush);
		if(Pull && EditMode==TURN) pDoc->PullCircle(SCALY.r/SCALY.scaly,&mDC);
		SetScrollSizes(MM_TEXT,pDoc->Show(&mDC));
		pDC->BitBlt(rect.left,rect.top,rect.right-rect.left,rect.bottom-rect.top,&mDC,rect.left,rect.top,SRCCOPY);
		mDC.DeleteDC();
	} else {
		if (Pull && EditMode==LINK) pDoc->PullLine(PullPoint,pDC);
		SetScrollSizes(MM_TEXT,pDoc->Show(pDC));
	}
	newScreen=false;
}

void CColorView::OnInitialUpdate()
{
	CScrollView::OnInitialUpdate();

	CSize sizeTotal;
	sizeTotal.cx = sizeTotal.cy = 100;
	SetScrollSizes(MM_TEXT, sizeTotal);
}

/////////////////////////////////////////////////////////////////////////////
// CColorView printing

BOOL CColorView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CColorView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

void CColorView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
}

/////////////////////////////////////////////////////////////////////////////
// CColorView diagnostics

#ifdef _DEBUG
void CColorView::AssertValid() const
{
	CScrollView::AssertValid();
}

void CColorView::Dump(CDumpContext& dc) const
{
	CScrollView::Dump(dc);
}

CColorDoc* CColorView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CColorDoc)));
	return (CColorDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CColorView message handlers

void CColorView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	point+=GetScrollPosition();
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(pDoc->MatrixDetect(point)) {PullPoint=point; OverMatrix=true;return;}
	switch(EditMode)
	{
	case TURN:
		SCALY.scaly=pDoc->Scaly(0);
		SCALY.r=pDoc->Distance(pDoc->GetCenter(),point);
		point-=pDoc->GetCenter();
		SCALY.angle=pDoc->Rotate(GET_ANGLE)*PI/180+atan2(point.x,point.y);
		break;
	case MOVE:
		PullPoint=point;
		break;
	case ADD:
		if (pDoc->Add(point)) Sound(IDW_ADD),pDoc->SetModifiedFlag(),fx.Add(point),Invalidate(pDoc->Matrix(false));
		break;
	case DEL:
		if(pDoc->CurrentTop!=-1) fx.Del(pDoc->GetTOP(pDoc->CurrentTop)),Sound(IDW_DEL);
		if(pDoc->Remove()) Invalidate();
		break;
	}
}

void CColorView::OnMouseMove(UINT nFlags, CPoint point) 
{
	point+=GetScrollPosition();
	double s;CPoint pointv;int f;
	mouse.Format("+%d,%d",point.x,point.y);
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	if(nFlags & MK_SHIFT && EditMode == ADD) point+=CPoint(TopSize,TopSize),point.x=(point.x/TopSize/2)*TopSize*2,point.y=(point.y/TopSize/2)*TopSize*2;
	if(nFlags & MK_LBUTTON) {
		if(OverMatrix)
		{
			PullMatrix=true; CPoint pos;
			pDoc->Matrix(false,&pos);
			pos+=point-PullPoint; PullPoint=point;
			if(pos.x<0) pos.x=0;
			if(pos.y<0) pos.y=0;
			pDoc->MatrixSet(pos);
			Invalidate();
			return;
		}
		switch(EditMode)
		{
		case MOVE: pDoc->Move(point-PullPoint); PullPoint=point; Invalidate(); break;
		case TURN:
			s=SCALY.scaly*pDoc->Distance(pDoc->GetCenter(),point)/SCALY.r;
			TRACE("x %d %d\n",pDoc->Distance(pDoc->GetCenter(),point),SCALY.r);
			TRACE("y %f %f\n",s,SCALY.scaly);
			if(s>3*SCALY.scaly) s=SCALY.scaly*3; pDoc->Scaly(s); 
			point-=pDoc->GetCenter();
			f=(int)((SCALY.angle-atan2(point.x,point.y))/PI*180);
			pDoc->Rotate(f);
			Pull=true; Invalidate(); break;
		case ADD: if (pDoc->CurrentTop>=0) pDoc->Set(pDoc->CurrentTop,point),Invalidate(); break;
		case LINK: if (pDoc->CurrentTop>=0) Pull=true, PullPoint=point, Invalidate(false); 
			else if (pDoc->SolveCurve(point)) Invalidate(); break;
		}

	} else
	{
		if (pDoc->MatrixDetect(point)) point.x=-99;
		if (pDoc->MatrixIsModify()) Invalidate(false);
		else if(pDoc->SelectTop(point)) Invalidate(false);
		else if(pDoc->SelectLink(point)) Invalidate(false);
	}
}



void CColorView::OnUpdateModeDel(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==DEL);
}

void CColorView::OnUpdateModeGrid(CCmdUI* pCmdUI) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetCheck(pDoc->Grid());
}

void CColorView::OnUpdateModeLink(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==LINK);
}

void CColorView::OnUpdateModeName(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==NAME);
}

void CColorView::OnUpdateModeTop(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==ADD);
}

void CColorView::OnModeDel() 
{
	EditMode=DEL;
}

void CColorView::OnModeGrid() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	Invalidate(!pDoc->Grid(true));
}

void CColorView::OnModeLink() 
{
	EditMode=LINK;
}

void CColorView::OnModeName() 
{
	EditMode=NAME;
}

void CColorView::OnModeTop() 
{
	EditMode=ADD;
}

void CColorView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	point+=GetScrollPosition();
	if(PullMatrix) { PullMatrix=OverMatrix=false; return;} else if(OverMatrix) {pDoc->MatrixClick(); Invalidate(); return;}
	Pull=false;
	if (EditMode==LINK) {
		if (pDoc->AddLink()) Sound(IDW_LINK);
		Invalidate();
	}
	if(EditMode==TURN) Invalidate();
}



void CColorView::OnModeBlack() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	Invalidate(!pDoc->Black(true));
}

void CColorView::OnUpdateModeBlack(CCmdUI* pCmdUI) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetCheck(pDoc->Black());
}

void CColorView::OnViewGrid1() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->GridDots(true,true);
	Invalidate();
}


void CColorView::OnViewGrid2() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->GridDots(true,false);
	Invalidate();
}

void CColorView::OnUpdateViewGrid1(CCmdUI* pCmdUI) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetCheck(pDoc->GridDots());
}

void CColorView::OnUpdateViewGrid2(CCmdUI* pCmdUI) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetCheck(!pDoc->GridDots());
}

void CColorView::OnUpdateMousePos(CCmdUI* pCmdUI) 
{
	pCmdUI->SetText(mouse);
}

void CColorView::OnUpdateTopsQuantity(CCmdUI* pCmdUI) 
{
	CString buffer;
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	buffer.Format(": %d",pDoc->GetTOPs());
	pCmdUI->SetText(buffer);
}

void CColorView::OnUpdateLinksQuantity(CCmdUI* pCmdUI) 
{
	CString buffer;
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	buffer.Format("и: %d",pDoc->GetLINKs());
	pCmdUI->SetText(buffer);
}


//DEL void CColorView::OnTest() 
//DEL {
//DEL 	CColorDoc* pDoc = GetDocument();
//DEL 	ASSERT_VALID(pDoc);
//DEL 	pDoc->test();
//DEL }


BOOL CColorView::OnEraseBkgnd(CDC* pDC) 
{
	newScreen=true; return false;
}


void CColorView::OnTimer(UINT nIDEvent) 
{
	if(fx.isActive()) Invalidate(false);
}


BOOL CColorView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	if(!CWnd::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext)) return false;
	SetTimer(1,100,0);
	return true;
}

void CColorView::OnReport() 
{
	ReportDialog dlg;
	dlg.DoModal();
}

void CColorView::OnOpengl() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc); 
	openGL dlg(pDoc);
	dlg.setup=pDoc->opengl;
	dlg.DoModal();
	pDoc->opengl=dlg.setup;
}

void CColorView::OnMoveDown() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Move(CPoint(0,5)); Invalidate();
}

void CColorView::OnModeUp() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Move(CPoint(0,-5)); Invalidate();
	
}

void CColorView::OnMoveLeft() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Move(CPoint(-5,0)); Invalidate();
	
}

void CColorView::OnMoveRight() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Move(CPoint(5,0)); Invalidate();
	
}

void CColorView::OnReduce() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Scaly(pDoc->Scaly(0)*0.95); Invalidate();
}

void CColorView::OnMagnify() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Scaly(pDoc->Scaly(0)*1.05); Invalidate();
}

void CColorView::OnRotate1() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Rotate(pDoc->Rotate(GET_ANGLE)+3); Invalidate();
}

void CColorView::OnRotate2() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Rotate(pDoc->Rotate(GET_ANGLE)-3); Invalidate();
}


void CColorView::OnModeMove() 
{
	EditMode=MOVE;
}

void CColorView::OnUpdateModeMove(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==MOVE);
}

void CColorView::OnModeTurn() 
{
	EditMode=TURN;
}

void CColorView::OnUpdateModeTurn(CCmdUI* pCmdUI) 
{
	pCmdUI->SetCheck(EditMode==TURN);
}

void CColorView::OnUpdateMode(CCmdUI* pCmdUI) 
{
	CString mode;
	switch (EditMode) {
	case ADD:  mode=" "; break;
	case LINK: mode=" "; break;
	case DEL:  mode=""; break;
	case NAME: mode=""; break;
	case MOVE: mode=" "; break;
	case TURN: mode=" "; break;
	default: mode="undefined"; break;
	}
	pCmdUI->SetText(": "+mode);
}

void CColorView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
   CColorDoc* pDoc = GetDocument();
   ASSERT_VALID(pDoc);
   CMenu menu, *pSubMenu; if(!menu.LoadMenu(IDR_CONTEXT)) return;
   pSubMenu = menu.GetSubMenu(0); if (!pSubMenu) return;
   if(pDoc->CurrentTop>=0) pSubMenu->InsertMenu(0,0,ID_CONT_DELETE," ");
   UpdateMenu(this,pSubMenu);
   ::TrackPopupMenu(pSubMenu->m_hMenu, 0,point.x,point.y, 0, pWnd->GetSafeHwnd(), NULL);
}

void CColorView::OnMatrix() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pDoc->Matrix(true,0);
	Invalidate();
}

void CColorView::OnUpdateMatrix(CCmdUI* pCmdUI) 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	pCmdUI->SetCheck(pDoc->Matrix(false,0));
}

void CColorView::OnViewMatrix() 
{
	CColorDoc* pDoc = GetDocument();
	pDoc->MatrixSetup(); Invalidate();
}

void CColorView::OnFileSave() 
{
	/////
}

void CColorView::OnFileSaveAs() 
{
	CColorDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
//	CFileDialog dlg(false,0,0,OFN_OVERWRITEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY,"  |*.gr||*.cgf|TeX |*.pic||");
	CFileDialog dlg(false,0,0,OFN_OVERWRITEPROMPT|OFN_ENABLESIZING|OFN_HIDEREADONLY,"TeX |*.pic||");
	if(dlg.DoModal()!=IDOK) return;
	FILE *handler=fopen(dlg.GetFileName(),"wb"); if(!handler) { AfxMessageBox("IO error",0,0); return;}
	pDoc->SaveAsTEX(handler);
	fclose(handler);
}
