// ColorView.h : interface of the CColorView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_COLORVIEW_H__793D8ECE_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
#define AFX_COLORVIEW_H__793D8ECE_230E_11D6_B8E1_F975CCF2E655__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "animate.h"

class CColorView : public CScrollView
{
protected: // create from serialization only
	CColorView();
	DECLARE_DYNCREATE(CColorView)
	enum {ADD,LINK,DEL,NAME,MOVE,TURN}EditMode;
	WORD Flags;
	CWnd wnd;

// Attributes
public:
	CColorDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColorView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
	protected:
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CColorView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	bool PullMatrix;	//   
	bool OverMatrix;	//   
	bool Pull;			//     
	CPoint PullPoint;	//     
	bool newScreen;		//   
	struct {double angle; int r; double scaly;}SCALY;	//   
	Animate fx;
// Generated message map functions
protected:
	CString mouse;
	//{{AFX_MSG(CColorView)
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnUpdateMode(CCmdUI* pCmdUI);
	afx_msg void OnUpdateMousePos(CCmdUI* pCmdUI);
	afx_msg void OnUpdateTopsQuantity(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLinksQuantity(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModeDel(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModeGrid(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModeLink(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModeName(CCmdUI* pCmdUI);
	afx_msg void OnUpdateModeTop(CCmdUI* pCmdUI);
	afx_msg void OnModeDel();
	afx_msg void OnModeGrid();
	afx_msg void OnModeLink();
	afx_msg void OnModeName();
	afx_msg void OnModeTop();
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnModeBlack();
	afx_msg void OnUpdateModeBlack(CCmdUI* pCmdUI);
	afx_msg void OnViewGrid1();
	afx_msg void OnViewGrid2();
	afx_msg void OnUpdateViewGrid1(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewGrid2(CCmdUI* pCmdUI);
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnReport();
	afx_msg void OnOpengl();
	afx_msg void OnMoveDown();
	afx_msg void OnModeUp();
	afx_msg void OnMoveLeft();
	afx_msg void OnMoveRight();
	afx_msg void OnReduce();
	afx_msg void OnRotate1();
	afx_msg void OnRotate2();
	afx_msg void OnMagnify();
	afx_msg void OnModeMove();
	afx_msg void OnUpdateModeMove(CCmdUI* pCmdUI);
	afx_msg void OnModeTurn();
	afx_msg void OnUpdateModeTurn(CCmdUI* pCmdUI);
	afx_msg void OnContextMenu(CWnd* pWnd, CPoint point);
	afx_msg void OnMatrix();
	afx_msg void OnUpdateMatrix(CCmdUI* pCmdUI);
	afx_msg void OnViewMatrix();
	afx_msg void OnFileSave();
	afx_msg void OnFileSaveAs();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
};

#ifndef _DEBUG  // debug version in ColorView.cpp
inline CColorDoc* CColorView::GetDocument()
   { return (CColorDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLORVIEW_H__793D8ECE_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
