// Graph.h: interface for the Graph class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_GRAPH_H__793D8ED6_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
#define AFX_GRAPH_H__793D8ED6_230E_11D6_B8E1_F975CCF2E655__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define GET_ANGLE 99999

#pragma pack(1)


#include <afxtempl.h>

class Graph  
{
public:
	struct linkST {CPoint point;WORD color;int curve;bool select;};
	struct topST {CPoint point;char *name;int z;};
public:
	void SaveAsMatrix(FILE*);
	void SaveAsTEX(FILE *);
	void Load(FILE *);
	void Save(FILE *);
	Graph();
	~Graph();
//-----[  ]-----
	int GetZ(int);			//
	void Del(int);			//
	bool Add(CPoint);		//
	void Set(int,CPoint);	//
	void SetZ(int,int);		//
	CPoint GetTOP(int);		//
	int GetTOPs();			//
//------[  ]------
	int GetColor(int );						//
	int GetCurve(int);						//
	bool AddLink(int x,int y,int curve=0);	//
	bool isSelect(int);						//
	bool HitToLink(int , CPoint);			//
	void DelLink(int);						//
	void SplitLink(int,int);				//
	bool SolveCurve(CPoint);				//
	bool SelectLink(CPoint);				//
	CPoint GetLINK(int);					//
	int GetLINKs();							//
	void SetColor(WORD,WORD);
//-------[  ]-------
	int Rotate(int);						//
	void Move(CPoint);						//
	double Scaly(double);					//
	CPoint GetCenter();						//
	CRect GetSize();						//
//-----[  ]-----
	int Distance(CPoint,CPoint);
	CPoint GetCircleCenter(CPoint ,CPoint,int);
//-----[debug]-----
protected:
	int GetDistance(int,CPoint);
	int FindCurrent(CPoint,int r=TopSize, int skip=-1);
private:
	void UnselectAll();			//
	void Canonize();			//
	void EvalueSize();			//
	void EvalueCenter();		//
	void UpdateSize(CPoint);	//
//debug
	void ReportClear();
	void Graph_();
	void MakeLinear();
//   
	CArray<topST,topST>tops;
	CArray<linkST,linkST>links;
	void Analiz();

	struct s1{CRect rect; CPoint center; bool isCenter; bool isSize;} SIZES;	//
	struct p1{CPoint offset; double scaly; WORD angle; } POSITION;				//
	double linear[2][2];	//
};

#endif // !defined(AFX_GRAPH_H__793D8ED6_230E_11D6_B8E1_F975CCF2E655__INCLUDED_)
