// Matrix.cpp : implementation file
//

#include "stdafx.h"
#include "Color.h"
#include "math.h"

#include "graph.h"
//#include "ColorView.h"


#include "Matrix.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// Matrix dialog


Matrix::Matrix(CScrollView *view_, Graph *graph_ , CWnd* pParent /*=NULL*/)
	: CDialog(Matrix::IDD, pParent)
{
	r=0; CellStyle=TOP;
	view=view_;
	graph=graph_;
	matrix.Install(graph->GetTOPs());
	for(int n=0; n<graph->GetLINKs(); n++) matrix.Set(graph->GetLINK(n),true);

	//{{AFX_DATA_INIT(Matrix)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void Matrix::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(Matrix)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(Matrix, CDialog)
	//{{AFX_MSG_MAP(Matrix)
	ON_WM_PAINT()
	ON_WM_CREATE()
	ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// Matrix message handlers

void Matrix::OnPaint() 
{
	if(matrix.GetSize()<2) EndDialog(0);
	KillTimer(1);
	CPaintDC dc(this); CPen *oldpen;
	int n,x,y; CString note; int rm=CellSize*matrix.GetSize()/2; DWORD ink;
	ink=ColorInterpolation(COLOR_3DFACE,COLOR_WINDOWTEXT,0,25,r);
	if(r<25)
	{
		CPen pen(0,1,ink);
		oldpen=dc.SelectObject(&pen);
		int dx,dy;
		double f=PI/25*r;
		x=(int)((sin(f)-cos(f))*rm/25*r); dx=(int)(+cos(f)*CellSize/25*r);
		y=(int)((cos(f)+sin(f))*rm/25*r); dy=(int)(-sin(f)*CellSize/25*r);
		for(n=0; n<=matrix.GetSize(); n++)
		dc.MoveTo(30+rm+x+dx*n,30+rm+y+dy*n),
		dc.LineTo(30+rm-y+dx*n,30+rm+x+dy*n),
		dc.MoveTo(30+rm+x+dy*n,30+rm+y-dx*n),
		dc.LineTo(30+rm+y+dy*n,30+rm-x-dx*n);
		SetTimer(1,30,0);
		dc.SelectObject(oldpen);
		return;
	}
	CRect rect;
	HICON icon0,icon1;

	switch(CellStyle)
	{
	case TOP:
		icon0=AfxGetApp()->LoadIcon(IDI_ICON1);
		icon1=AfxGetApp()->LoadIcon(IDI_ICON3);
		for(y=0; y<matrix.GetSize(); y++)
		for(x=0; x<matrix.GetSize(); x++)
		DrawIconEx(dc.m_hDC,x*CellSize+8,y*CellSize+8,matrix.Get(x,y) ? icon1 : icon0,TopSize,TopSize,0,0,0);
		break;
	case CHECK:
		for(y=0; y<matrix.GetSize(); y++)
		for(x=0; x<matrix.GetSize(); x++)
		rect.bottom=y*32+8,
		rect.top=y*32+24,
		rect.left=y*32+8,
		rect.right=y*32+24,
		DrawFrameControl(dc.m_hDC,&rect,matrix.Get(x,y) ? DFCS_CHECKED : 0,DFCS_BUTTONCHECK);
		break;
	case BUTTON:
		for(y=0; y<matrix.GetSize(); y++)
		for(x=0; x<matrix.GetSize(); x++)
		rect.bottom=y*32+8,
		rect.top=y*32+24,
		rect.left=y*32+8,
		rect.right=y*32+24,
		DrawFrameControl(dc.m_hDC,&rect,matrix.Get(x,y) ? DFCS_PUSHED : 0,DFCS_BUTTONPUSH);
		break;
	case NORMAL:
		CPen pen(0,2,ink);
		oldpen=dc.SelectObject(&pen);
		for(n=0; n<=matrix.GetSize(); n++)
			dc.MoveTo(30+n*CellSize,30),
			dc.LineTo(30+n*CellSize,30+matrix.GetSize()*CellSize),
			dc.MoveTo(30,30+n*CellSize),
			dc.LineTo(30+matrix.GetSize()*CellSize,30+n*CellSize);
			dc.SelectObject(oldpen);
		CBrush brush(RGB(-1,0,0));
		CBrush *oldbrush=dc.SelectObject(&brush);
//		dc.FillRect(CRect(x,y,x+CellSize-6,y+CellSize-6),&brush);
		break;
	}
}

//		CBrush brush(c);
//		x=30+b*PeekSize+3; y=30+a*PeekSize+3;
//		dc.FillRect(CRect(x,y,x+PeekSize-5,y+PeekSize-5),&brush);



void Matrix::EvalueCell()
{
	switch(CellStyle)
	{
	case TOP: CellSize=TopSize+16; break;
	case CHECK:
	case BUTTON: CellSize=32; break;
	case NORMAL: CellSize=100/matrix.GetSize(); if(CellSize<16) CellSize=16; break;
	}
	int n=matrix.GetSize()*CellSize;
	SetWindowPos(0,0,0,60+n,80+n,SWP_NOMOVE);
}

int Matrix::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1) return -1;
	EvalueCell(); Sound(IDW_OPEN);
	return 0;
}

void Matrix::OnTimer(UINT nIDEvent) 
{
	r++; Invalidate();
	CDialog::OnTimer(nIDEvent);
}
